--modified to display persentage and run under Empire
include std\utility.em
include binary.e
global constant num = 16,
                bfdat = "Blowfish.dat"
sequence P, S
integer fn

P = repeat(0, num + 2)
S = repeat(repeat(0, 256), 4)

function Wrap(atom temp)
    while temp >= 2147483648 do
        temp -= 4294967296
    end while
    while temp < -2147483648 do
        temp += 4294967296
    end while
--    temp = bits_to_int(int_to_bits(temp, 32))
    return temp
end function

function F(atom x)
integer a
integer b
integer c
integer d
atom e
    d = and_bits(x, #FF) + 1
    c = and_bits(x, #FF00) / #100 + 1
    b = and_bits(x, #FF0000) / #10000 + 1
    a = and_bits(x, #FF000000) / #1000000 + 1
    if d <= 0 then d += 256 end if
    if c <= 0 then c += 256 end if
    if b <= 0 then b += 256 end if
    if a <= 0 then a += 256 end if
    e = S[1][a] + S[2][b]
    e = Wrap(e)
    e = xor_bits(e, S[3][c])
    e += S[4][d]
    e = Wrap(e)
    return e
end function

function encipher_8byte(atom xl, atom xr)
atom temp
    for a = 1 to num do
        xl = xor_bits(xl, P[a])
        xr = xor_bits(F(xl), xr)
        temp = xl
        xl = xr
        xr = temp
    end for
    temp = xl
    xl = xr
    xr = temp
    xr = xor_bits(xr, P[num+1])
    xl = xor_bits(xl, P[num+2])
    if xl < 0 then
        xl += #100000000
    end if
    if xr < 0 then
        xr += #100000000
    end if
    return {xl, xr}
end function

function decipher_8byte(atom xl, atom xr)
atom temp
    for a = num + 2 to 3 by -1 do
        xl = xor_bits(xl, P[a])
        xr = xor_bits(F(xl), xr)
        temp = xl
        xl = xr
        xr = temp
    end for
    temp = xl
    xl = xr
    xr = temp
    xr = xor_bits(xr, P[2])
    xl = xor_bits(xl, P[1])
    if xl < 0 then
        xl += #100000000
    end if
    if xr < 0 then
        xr += #100000000
    end if
    return {xl, xr}
end function

global function init_blowfish(sequence key)
sequence bytes, ret
atom hd
atom ld
integer charnum
    fn = open(bfdat, "rb")
    if fn = -1 then return 0 end if
    for a = 1 = 1 to num + 2 do
        bytes = getn(fn, 4)
        P[a] = bytes_to_int(bytes)
    end for
    for a = 1 to 4 do
        for b = 1 to 256 do
            bytes = getn(fn, 4)
            S[a][b] = bytes_to_int(bytes)
        end for
    end for
    close(fn)
    charnum = 1
    for a = 1 to num + 2 do
        P[a] = 0
        for b = 1 to 4 do
            P[a] = or_bits(P[a] * 256, key[charnum])
            charnum += 1
            if charnum > length(key) then charnum = 1 end if
        end for
    end for
    hd = 0
    ld = 0
    for a = 1 to num + 2 by 2 do
        ret = encipher_8byte(ld, hd)
        P[a] = ret[1]
        P[a+1] = ret[2]
    end for
    for a = 1 to 4 do
        for b = 1 to 256 by 2 do
            ret = encipher_8byte(ld, hd)
            S[a][b] = ret[1]
            S[a][b+1] = ret[2]
        end for
    end for
    return 1
end function

global function Blowfish_Encipher_Bytes(sequence bytes, integer typ)
sequence output
integer padding
sequence sel, ret, oldsel, curpos
atom xl, xr, timer
    padding = remainder(length(bytes), 8)
    if padding != 0 then
        padding = 8 - padding
    end if
    bytes &= repeat(0, padding)
    output = repeat(0, length(bytes))
    if typ = 1 then
        oldsel = repeat(0, 8)
    end if
    curpos = get_position()
    timer = time()
    for a = 1 to length(bytes) by 8 do
        if time() - timer >= 1 then
            position(curpos[1], curpos[2])
            print(1, floor((a-1) / (length(bytes)-1) * 100))
            puts(1, "%")
            timer = time()
        end if
        sel = bytes[a..a+7]
        if typ = 1 then
            sel = xor_bits(sel, oldsel)
        end if
        xl = bytes_to_int(sel[1..4])
        xr = bytes_to_int(sel[5..8])
        ret = encipher_8byte(xl, xr)
        output[a..a+3] = int_to_bytes(ret[1])
        output[a+4..a+7] = int_to_bytes(ret[2])
        if typ = 1 then
            oldsel = int_to_bytes(ret[1]) & int_to_bytes(ret[2])
        end if
    end for
    output = padding & output

    position(curpos[1], curpos[2])
    puts(1, "100%")

    return output
end function

global function Blowfish_Decipher_Bytes(sequence bytes, integer typ)
sequence output
integer padding
sequence sel, ret, oldsel, sel2
atom xl, xr
    if length(bytes) = 0 then return {} end if
    padding = bytes[1]
    if length(bytes) = 1 then
        bytes = {}
    else
        bytes = bytes[2..length(bytes)]
    end if
    output = repeat(0, length(bytes))
    if typ = 1 then
        oldsel = repeat(0, 8)
    end if
    for a = 1 to length(bytes) by 8 do
        sel = bytes[a..a+7]
        xl = bytes_to_int(sel[1..4])
        xr = bytes_to_int(sel[5..8])
        ret = decipher_8byte(xl, xr)
        if typ = 1 then
            sel2 = int_to_bytes(ret[1]) & int_to_bytes(ret[2])
            sel2 = xor_bits(sel2, oldsel)
            output[a..a+7] = sel2
            oldsel = sel
        else
            output[a..a+3] = int_to_bytes(ret[1])
            output[a+4..a+7] = int_to_bytes(ret[2])
        end if
    end for
    if length(output) - padding < 1 then
        output = {}
    else
        output = output[1..length(output)-padding]
    end if
    return output
end function

global function Blowfish_Encipher_Sequence(sequence seq, integer typ)
    return Blowfish_Encipher_Bytes(EncodeObject(seq), typ)
end function

global function Blowfish_Decipher_Sequence(sequence seq, integer typ)
    return DecodeObject(Blowfish_Decipher_Bytes(seq, typ))
end function
