--this implementation of md5 doesn't give the same output as the official
--but I think it works good enough

--modified to display persentage and run under Empire
include std\mem.em
include std\utility.em
constant ax = 1, bx = 2, cx = 3, dx = 4
sequence x
atom F_id, G_id, H_id, I_id

constant S11 = 7, S12 = 12, S13 = 17, S14 = 2
constant S21 = 5, S22 = 9, S23 = 14, S24 = 20
constant S31 = 4, S32 = 11, S33 = 16, S34 = 23
constant S41 = 6, S42 = 10, S43 = 15, S44 = 21

function F(atom x, atom y, atom z)
    return or_bits(and_bits(x, y), and_bits(not_bits(x), z))
end function
function G(atom x, atom y, atom z)
    return or_bits(and_bits(x, z), and_bits(y, not_bits(z)))
end function
function H(atom x, atom y, atom z)
    return xor_bits(xor_bits(x, y), z)
end function
function I(atom x, atom y, atom z)
    return xor_bits(y, or_bits(x, not_bits(z)))
end function

F_id = routine_id("F")
G_id = routine_id("G")
H_id = routine_id("H")
I_id = routine_id("I")

function Wrap(atom temp)
    while temp >= 2147483648 do
        temp -= 4294967296
    end while
    while temp < -2147483648 do
        temp += 4294967296
    end while
--    temp = bits_to_int(int_to_bits(temp, 32))
    return temp
end function

function rotate_left(atom x, atom n)
sequence temp
    temp = int_to_bits(x, 32)
    temp = temp[32-n+1..32] & temp[1..32-n]
--    temp = temp[n+1..32] & temp[1..n]
    return bits_to_int(temp)
end function

procedure Transform(integer a, integer b, integer c, integer d, atom x2, atom s, atom ac, atom func)
    x[a] += call_func(func, {x[b], x[c], x[d]}) + x2 + ac
    x[a] = Wrap(x[a])
    x[a] = rotate_left(x[a], s)
    x[a] += x[b]
    x[a] = Wrap(x[a])
end procedure

function QWord_To_Bytes(atom qword)
atom dword1, dword2
    dword1 = floor(remainder(qword, #100000000 + .5))
    dword2 = floor((qword - dword1) / #100000000 + .5)
    dword2 = floor(remainder(dword2, #100000000 + .5))
    return int_to_bytes(dword1) & int_to_bytes(dword2)
end function

function Bytes_To_Hex(sequence inp)
sequence out, chars
integer upper, lower
    chars = {'0', '1', '2', '3', '4', '5', '6', '7', '8', '9', 'A', 'B', 'C', 'D', 'E', 'F'}
    out = ""
    for a = 1 to length(inp) do
        lower = and_bits(inp[a], #F)
        upper = and_bits(floor((inp[a] - lower) / #10), #F)
        out &= chars[upper+1]
        out &= chars[lower+1]
    end for
    return out
end function

global function Gen_MD5_Bytes(sequence bytes)
integer mod64, addbytes
atom len, timer
sequence x2, oldx, out, curpos
    mod64 = remainder(length(bytes), 64)
    if mod64 < 56 then
        addbytes = 56 - mod64
    else
        addbytes = 64 - (mod64 - 56)
    end if
    len = length(bytes) * 8
    bytes &= #80
    bytes &= repeat(0, addbytes-1)
    bytes &= QWord_To_Bytes(len)

--    print(1, bytes)
--    puts(1, "\n")
--    print(1, length(bytes) / 64)
--    puts(1, "\n")

    x = {#67452301, #EFCDAB89, #98BADCFE, #10325476}
    timer = time()
    curpos = get_position()
    for i = 1 to length(bytes) by 64 do
        if time() - timer >= 1 then
            position(curpos[1], curpos[2])
            print(1, floor((i-1) / (length(bytes)-1) * 100))
            puts(1, "%")
            timer = time()
        end if
        oldx = x
        x2 = repeat(0, 16)
        for j = 1 to 16 do
            x2[j] = bytes_to_int(bytes[i+(j-1)*4..i+(j-1)*4+3])
        end for

        Transform(ax, bx, cx, dx, x2[1], S11, #D76AA478, F_id)
        Transform(dx, ax, bx, cx, x2[2], S12, #E8C7B756, F_id)
        Transform(cx, dx, ax, bx, x2[3], S13, #242070DB, F_id)
        Transform(bx, cx, dx, ax, x2[4], S14, #C1BDCEEE, F_id)

        Transform(ax, bx, cx, dx, x2[5], S11, #F57C0FAF, F_id)
        Transform(dx, ax, bx, cx, x2[6], S12, #4787C62A, F_id)
        Transform(cx, dx, ax, bx, x2[7], S13, #A8304613, F_id)
        Transform(bx, cx, dx, ax, x2[8], S14, #FD469501, F_id)

        Transform(ax, bx, cx, dx, x2[9], S11, #698098D8, F_id)
        Transform(dx, ax, bx, cx, x2[10], S12, #8B44F7AF, F_id)
        Transform(cx, dx, ax, bx, x2[11], S13, #FFFF5BB1, F_id)
        Transform(bx, cx, dx, ax, x2[12], S14, #895CD7BE, F_id)

        Transform(ax, bx, cx, dx, x2[13], S11, #6B901122, F_id)
        Transform(dx, ax, bx, cx, x2[14], S12, #FD987193, F_id)
        Transform(cx, dx, ax, bx, x2[15], S13, #A679438E, F_id)
        Transform(bx, cx, dx, ax, x2[16], S14, #49B40821, F_id)

        Transform(ax, bx, cx, dx, x2[2], S21, #F61E2562, G_id)
        Transform(dx, ax, bx, cx, x2[7], S22, #C040B340, G_id)
        Transform(cx, dx, ax, bx, x2[12], S23, #265E5A51, G_id)
        Transform(bx, cx, dx, ax, x2[1], S24, #E9B6C7AA, G_id)

        Transform(ax, bx, cx, dx, x2[6], S21, #D62F105D, G_id)
        Transform(dx, ax, bx, cx, x2[11], S22, #2441453, G_id)
        Transform(cx, dx, ax, bx, x2[16], S23, #D8A1E681, G_id)
        Transform(bx, cx, dx, ax, x2[5], S24, #E7D3FBC8, G_id)

        Transform(ax, bx, cx, dx, x2[10], S21, #21E1CDE6, G_id)
        Transform(dx, ax, bx, cx, x2[15], S22, #C33707D6, G_id)
        Transform(cx, dx, ax, bx, x2[4], S23, #F4D50D87, G_id)
        Transform(bx, cx, dx, ax, x2[9], S24, #455A14ED, G_id)

        Transform(ax, bx, cx, dx, x2[14], S21, #A9E3E905, G_id)
        Transform(dx, ax, bx, cx, x2[3], S22, #FCEFA3F8, G_id)
        Transform(cx, dx, ax, bx, x2[8], S23, #676F02D9, G_id)
        Transform(bx, cx, dx, ax, x2[13], S24, #8D2A4C8A, G_id)

        Transform(ax, bx, cx, dx, x2[6], S31, #FFFA3942, H_id)
        Transform(dx, ax, bx, cx, x2[9], S32, #8771F681, H_id)
        Transform(cx, dx, ax, bx, x2[12], S33, #6D9D6122, H_id)
        Transform(bx, cx, dx, ax, x2[15], S34, #FDE5380C, H_id)

        Transform(ax, bx, cx, dx, x2[2], S31, #A4BEEA44, H_id)
        Transform(dx, ax, bx, cx, x2[5], S32, #4BDECFA9, H_id)
        Transform(cx, dx, ax, bx, x2[8], S33, #F6BB4B60, H_id)
        Transform(bx, cx, dx, ax, x2[11], S34, #BEBFBC70, H_id)

        Transform(ax, bx, cx, dx, x2[14], S31, #289B7EC6, H_id)
        Transform(dx, ax, bx, cx, x2[1], S32, #EAA127FA, H_id)
        Transform(cx, dx, ax, bx, x2[4], S33, #D4EF3085, H_id)
        Transform(bx, cx, dx, ax, x2[7], S34, #4881D05, H_id)

        Transform(ax, bx, cx, dx, x2[10], S31, #D9D4D039, H_id)
        Transform(dx, ax, bx, cx, x2[13], S32, #E6DB99E5, H_id)
        Transform(cx, dx, ax, bx, x2[16], S33, #1FA27CF8, H_id)
        Transform(bx, cx, dx, ax, x2[3], S34, #C4AC5665, H_id)

        Transform(ax, bx, cx, dx, x2[1], S41, #F4292244, I_id)
        Transform(dx, ax, bx, cx, x2[8], S42, #432AFF97, I_id)
        Transform(cx, dx, ax, bx, x2[15], S43, #AB9423A7, I_id)
        Transform(bx, cx, dx, ax, x2[6], S44, #FC93A039, I_id)

        Transform(ax, bx, cx, dx, x2[13], S41, #655B59C3, I_id)
        Transform(dx, ax, bx, cx, x2[4], S42, #8F0CCC92, I_id)
        Transform(cx, dx, ax, bx, x2[11], S43, #FFEFF47D, I_id)
        Transform(bx, cx, dx, ax, x2[2], S44, #85845DD1, I_id)

        Transform(ax, bx, cx, dx, x2[9], S41, #6FA87E4F, I_id)
        Transform(dx, ax, bx, cx, x2[16], S42, #FE2CE6E0, I_id)
        Transform(cx, dx, ax, bx, x2[7], S43, #A3014314, I_id)
        Transform(bx, cx, dx, ax, x2[14], S44, #4E0811A1, I_id)

        Transform(ax, bx, cx, dx, x2[5], S41, #F7537E82, I_id)
        Transform(dx, ax, bx, cx, x2[12], S42, #BD3AF235, I_id)
        Transform(cx, dx, ax, bx, x2[3], S43, #2AD7D2BB, I_id)
        Transform(bx, cx, dx, ax, x2[10], S44, #EB86D391, I_id)

        x += oldx
        x[ax] = Wrap(x[ax])
        x[bx] = Wrap(x[bx])
        x[cx] = Wrap(x[cx])
        x[dx] = Wrap(x[dx])

    end for
    
    out = Bytes_To_Hex(int_to_bytes(x[ax]) & int_to_bytes(x[bx]) & int_to_bytes(x[cx]) & int_to_bytes(x[dx]))
    
    position(curpos[1], curpos[2])
    puts(1, "100%")

    return out
end function
