---------------------------------------------
-- CHAR and STRING TYPES --
global type char(object c)
  if integer(c) then
    if c >=-1 and c <=255 then return 1 end if
  end if
  return 0
end type

global type string(object s) -- same as char_array()
  if atom(s) then return 0 end if
  for i = 1 to length(s) do
    if not char(s[i]) then return 0 end if
  end for
  return 1
end type

---------------------------------------------
-- STANDARD ATOMIC TYPES --

global type boolean(object b)
  return integer(b) and (b=1 or b=0)
end type

global type word(object w)
  return integer(w) and ((0 <= w) and (w <=65535))
end type


---------------------------------------------
-- STANDARD ARRAY TYPES --
global type boolean_array(object s)
  if atom(s) then
    return 0
  else
    for i = 1 to length(s) do
      if not boolean(s[i]) then return 0 end if
    end for
    return 1
  end if
end type

global type word_array(object s)
  if atom(s) then
    return 0
  else
    for i = 1 to length(s) do
      if not word(s[i]) then return 0 end if
    end for
    return 1
  end if
end type

global type integer_array(object s)
  if atom(s) then
    return 0
  else
    for i = 1 to length(s) do
      if not integer(s[i]) then return 0 end if
    end for
    return 1
  end if
end type

global type atom_array(object s)
  if atom(s) then
    return 0
  else
    for i = 1 to length(s) do
      if not atom(s[i]) then return 0 end if
    end for
    return 1
  end if
end type

global type sequence_array(object s)
  if atom(s) then
    return 0
  else
    for i = 1 to length(s) do
      if not sequence(s[i]) then return 0 end if
    end for
    return 1
  end if
end type

global type string_array(object s)
  if atom(s) then
    return 0
  else
    for i = 1 to length(s) do
      if not string(s[i]) then return 0 end if
    end for
    return 1
  end if
end type


-------------------------------------------------
-- EXTRA TYPES --
global type natural(object x)
  return integer(x) and (x >= 0)
end type

global type positive_int(object x)
  return integer(x) and (x > 0)
end type

global type negative_int(object x)
  return integer(x) and (x < 0)
end type

global type positive_atom(object x)
  return atom(x) and (x >= 0)
end type

global type negative_atom(object x)
  return atom(x) and (x <= 0)
end type
