include std/core.em

type seq_slice(object s)
  if atom(s) then return 1 end if
  if length(s)=2 then
    if integer(s[1]) and integer(s[2]) then
      return 1
    end if
  end if
  return 0
end type

global function splice(sequence s, seq_slice indices, object x)
  if atom(indices) then indices = {indices,indices} end if
  return s[1..indices[1]-1] & x & s[indices[2]+1..length(s)]
end function


global function reverse(sequence s)
-- reverse the top-level elements of a sequence.
-- Thanks to Hawke' for helping to make this run faster.
 integer low, n, n2
 sequence t
 
   n  = length(s)
   n2 = floor(n/2+0.5)
   t  = repeat(0, n)
   low = 1
   for high = n to n2 by -1 do
      t[high] = s[low]
      t[low] = s[high]
      low += 1
   end for
   return t
end function


global function flatten(object x)
 sequence ret
  if sequence(x) then
    ret = {}
    for i = 1 to length(x) do
      ret &= flatten(x[i])
    end for
    return ret
  end if
  return x
end function
