include std/core.em


type frequency(integer x)
  return x >= 0
end type

global procedure sound(frequency f) -- M_SOUND           = 1     --
-- turn on speaker at frequency f
-- turn off speaker if f is 0
  machine_proc(M_SOUND, f)
end procedure

global procedure beep(frequency f, atom duration, atom interval, integer count)
-- set sound(frequency), beep for 'duration', pausing for 'interval', between beeps
-- count is the number of beeps
 atom t
  t = time()
  for i = 1 to count do
    sound(f)
    t = time()
    while (time()-t) < duration do end while
    sound(OFF)
    t = time()
    while (time()-t) < interval do end while
  end for
end procedure


global procedure tick_rate(atom rate) -- M_TICK_RATE       = 38    --
-- Specify the number of clock-tick interrupts per second.
-- This determines the precision of the time() library routine, 
-- and also the sampling rate for time profiling.
    machine_proc(M_TICK_RATE, rate)
end procedure

global procedure allow_break(boolean b) -- M_ALLOW_BREAK     = 42    --
-- If b is TRUE then allow control-c/control-break to
-- terminate the program. If b is FALSE then don't allow it.
-- Initially they *will* terminate the program, but only when it
-- tries to read input from the keyboard.
    machine_proc(M_ALLOW_BREAK, b)
end procedure

global function check_break() -- M_CHECK_BREAK     = 43    --
-- returns the number of times that control-c or control-break
-- were pressed since the last time check_break() was called
    return machine_func(M_CHECK_BREAK, NULL)
end function

global procedure free_console() -- M_FREE_CONSOLE    = 54
-- delete the console text-window (if one currently exists)
  machine_proc(M_FREE_CONSOLE, NULL)
end procedure

global procedure sleep(positive_int t) -- M_SLEEP           = 64    -- proc(int>0)
-- go to sleep for t seconds
-- allowing (on WIN32 and Linux) other processes to run
  if t > 0 then
  	machine_proc(M_SLEEP, t)
  end if
end procedure
