include std/core.em
include std/util/string.e
include std/token.e

---------------------------------------------------------------------------------
sequence Buffer   Buffer = {-1}
integer Bi        Bi = 0
procedure set_buffer(string s)
  Bi = 0
  Buffer = s
end procedure

function readb()
  Bi +=1
  if Bi > length(Buffer) then
   return -1
  end if
 return Buffer[Bi]
end function

function get_hex_value()
 atom v
 integer c
  c = readb()
  v = 0
  while hex_char(c) do
    if digit_char(c) then
      c -='0'
    else
      if c < 'a' then c = c-'A'+10
      else            c = c-'a'+10
      end if
    end if
    v = v*16 + c
    c = readb()
  end while
 return v
end function

function get_exponential_value(atom v)
 atom e
 integer c,sign
  e = 0
  sign = 1
  c = readb()
  if    c = '-' then
    sign = -1
    c = readb()
  elsif c = '+' then
    c = readb()
  end if
  while c != -1 do
    if digit_char(c) then
      e = e*10 + (c-'0')
      c = readb()
    else
     exit
    end if
  end while

  e *= sign

  if e > 308 then
    v *= power(10,308)
    if e > 1000 then e = 1000 end if
    for i = 1 to e-308 do
      v *=10
    end for
  else
    v *= power(10,e)
  end if
 return v
end function

function get_decimal_value(integer c, integer sign)
 atom v,f,d
  v = 0
  f = 0
  d = 10

  -- integer
  while c != -1 do
    if digit_char(c) then
      v = v*10 + (c-'0')
      c = readb()
    else
     exit
    end if
  end while

  -- fraction
  if c = '.' then
    c = readb()
    while c != -1 do
      if digit_char(c) then
        f += (c-'0') / d
        d *=10
        c = readb()
      else
       exit
      end if
    end while
    v += f
  end if

  v *= sign

  -- exponential
  if c = 'e' then
    v = get_exponential_value(v)
  end if

 return v
end function

global function get_value(string s)
 atom v,f,e
 integer sign,d,c
  v = 0   -- value
  f = 0   -- fraction
  d = 10  -- divisor
  e = 0   -- exponential
  sign = 1

  set_buffer(s)
  c = readb()

  -- sign
  if    c = '-' then
    sign = -1
    c = readb()
  elsif c = '+' then
    c = readb()
  end if

  if c = '#' then -- hex
   return sign * get_hex_value()
  else -- decimal
   return get_decimal_value(c,sign)
  end if
end function
